#include <stdio.h>
#include <stdlib.h>

int main()
{
    int brVaga, brPitanja, *donjeGranice, *gornjeGranice, i, j, pocetniIndeks, krajnjiIndeks, tezina;
    char* rezultat;
    scanf("%d %d", &brVaga, &brPitanja);

    donjeGranice = (int*)malloc(brVaga * sizeof(int));
    gornjeGranice = (int*)malloc(brVaga * sizeof(int));
    rezultat = (int*)malloc(brPitanja * sizeof(char));

    for (i = 0; i < brVaga; i++)
    {
        scanf("%d %d", &donjeGranice[i], &gornjeGranice[i]);
    }

    for (i = 0; i < brPitanja; i++)
    {
        scanf("%d %d %d", &pocetniIndeks, &krajnjiIndeks, &tezina);
        j = pocetniIndeks - 1;
        while (j < krajnjiIndeks && (tezina < donjeGranice[j] || tezina > gornjeGranice[j]))
            j++;
        if (j < krajnjiIndeks)
            rezultat[i]= '1';
        else
            rezultat[i] = '0';
    }
    for (i = 0; i < brPitanja; i++)
    {
        printf("%c\n", rezultat[i]);
    }
    free(donjeGranice);
    free(gornjeGranice);
    free(rezultat);
    return 0;
}